<template>
  <section>
    <div class="card">
      <nav class="navbar has-background-white-bis">
        <div class="navbar-brand">
          <span class="navbar-item title is-2">Agregar Ranking</span>
        </div>
        <div class="navbar-end">
          <div class="navbar-item">
            <div class="field">
              <b-switch type="is-twitter">Salir al guardar</b-switch>
            </div>
          </div>
        </div>
      </nav>
      <div class="section">
        <form @submit.prevent="validate">
          <div class="columns is-multiline">
             <div class="column is-6">
              <b-field
                label="Tipo de Ranking*"
                :type="{ 'is-danger': errors.has('rankingType') }"
                :message="errors.first('rankingType')"
              >
                 <multiselect 
                 v-model="model.rankingType" 
                 :options="rankingTypes" 
                 select-label=""
                  :preserve-search="true"
                  @select="onSelectRankingType" 
                 placeholder="Seleccionar Tipo de ranking" label="label" track-by="rankingType"  />
              </b-field>
            </div>
            <div class="column is-6">
              <b-field
                label="Ranking*"
                :type="{ 'is-danger': errors.has('playerRanking') }"
                :message="errors.first('playerRanking')"
              >
                <b-input
                  size="is-medium"
                  v-model="model.playerRanking"
                  name="playerRanking"
                  data-vv-as="playerRanking"
                  v-validate="'required'"
                  placeholder="Requerido"
                />
              </b-field>
            </div>
            <div class="column is-6">
              <b-field
                label="Jugador*"
                :type="{ 'is-danger': errors.has('player') }"
                :message="errors.first('player')"
              >
                 <multiselect 
                 v-model="name" 
                 :options="players" 
                 :multiple="false" 
                 select-label=""
                 :close-on-select="true" 
                 :clear-on-select="false"
                  :preserve-search="true"
                  @select="onSelectPlayer" 
                 placeholder="Seleccionar Jugador" label="fullName" track-by="fullName" />
              </b-field>
            </div>
            <div class="column is-6">
              <b-field
                label="Jugador 2*"
                :type="{ 'is-danger': errors.has('player2') }"
                :message="errors.first('player2')"
              >
                 <multiselect 
                 v-model="player2" 
                 :options="players" 
                 :disabled="enableSecondPlayer"
                 select-label=""
                  :preserve-search="true"
                  @select="onSelectPlayer2" 
                 placeholder="Seleccionar Jugador" label="fullName" track-by="fullName" />
              </b-field>
            </div>
             <div class="column is-6">
              <b-field
                label="Asociación*"
                :type="{ 'is-danger': errors.has('association') }"
                :message="errors.first('association')"
              >
                 <multiselect 
                 v-model="city" 
                 :options="associations" 
                 select-label=""
                  :preserve-search="true"
                  @select="onSelectAssociation" 
                 placeholder="Seleccionar Asociación" label="city" track-by="fullName" />
              </b-field>
            </div>
            <div class="column is-6">
              <b-field
                label="Puntos*"
                :type="{ 'is-danger': errors.has('point') }"
                :message="errors.first('point')"
              >
                <b-input
                  size="is-medium"
                  v-model="model.point"
                  name="point"
                  data-vv-as="point"
                  v-validate="'required'"
                  placeholder="Requerido"
                />
              </b-field>
            </div>
          </div>
          <nav class="level">
            <!-- Left side -->
            <div class="level-left">
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-light"
                  @click="clean"
                  icon-right="eraser"
                  >Limpiar</b-button
                >
              </p>
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-danger"
                  @click="cancel"
                  icon-right="cancel"
                  >Cancelar</b-button
                >
              </p>
            </div>
            <!-- Right side -->
            <div class="level-right">
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-primary"
                  native-type="submit"
                  icon-right="content-save"
                  >Guardar</b-button
                >
              </p>
            </div>
          </nav>
        </form>
      </div>
    </div>
  </section>
</template>
<script lang="ts">
import { Component, Vue, Watch } from "vue-property-decorator";
import BaseVue from "../../core/BaseVue";
import RankingModel from '../../models/ranking.model';
import RankingService from '../../services/rankingService';
  import multiselect from 'vue-multiselect'
import Player from "@/models/player/player.model";
import PlayerService from "@/services/player.service";
import { Utils } from "@/core/Utils";
import { RankingType } from "@/enums/rankingType";
import AssociationService from "@/services/associationService";
import AssociationModel from "@/models/association.model";
@Component({components:{
  multiselect
}})
export default class RankingEdit extends BaseVue {
  rankingService: RankingService = new RankingService();
  playerService:PlayerService = new PlayerService();
 associationService:AssociationService = new AssociationService();
  model: RankingModel;
    associations:Array<AssociationModel> =[];
  enableSecondPlayer:boolean = true;
  players:Array<Player> =[];
   optionSelected:string = "";
  name:string = "";
  city:string = "";
  rankingId:number = 0;
    rankingTypes:Array<any> = [
        { rankingType: 1, label: 'Masculino Individual' },
        { rankingType: 2, label: 'Femenina Individual' },
        { rankingType: 3, label: 'Doble Masculino' },
        { rankingType: 4, label: 'Doble Femeninas' },
        { rankingType: 5, label: 'Doble Mixto' }
      ]
  constructor() {
    super();
    this.model = new RankingModel();
     this.rankingId = Number(this.$route.params.id);
  }

  created(){
    this.getRankingById();
  }

  onSelectRankingType(item:any){

  switch (item.value) {
    case RankingType.DOUBLEFAMLE:
          this.getWPlayers();
      break;
       case RankingType.FEMALESINGLE:
          this.getWPlayers();
      break;
       case RankingType.DOUBLEMALE:
          this.getMPlayers();
      break;
       case RankingType.MALESINGLE:
          this.getMPlayers();
      break;
        case RankingType.DOUBLEMIX:
          this.getPlayers();
      break;
  
    default:
      break;
  }
  }



onSelectPlayer(player:Player){
    this.model.playerId =player.id;
}
  public cancel() {
    this.$router.push(`${this.$router.currentRoute.path.split("/editar")[0]}`);
  }

    getRankingById() {
    this.rankingService
      .getRankingById(this.rankingId)
      .then((resp) => {
        Utils.mapToObject(resp.data, this.model);
      })
      
  }


  
   getPlayers(){
     this.playerService.getPlayer().then((resp:any) =>{
         this.players = resp.data;
     });
   }

   getMPlayers(){
     this.playerService.getMan().then((resp:any) =>{
         this.players = resp.data;
     });
   }
    getWPlayers(){
     this.playerService.getWoman().then((resp:any) =>{
         this.players = resp.data;
     });
   }
     getAssociation(){
     this.associationService.getAssociation().then(resp =>{
         this.associations = resp.data;
     })
  }

  public async validate() {
    debugger
    try {
      var result = await this.$validator.validateAll();
      if (result) {
            this.model.playerId = Number(this.model.playerId);
            this.model.player2Id = this.model.player2Id !== null ? Number(this.model.player2Id) : null;
            this.model.point = Number(this.model.point);
               this.model.playerRanking = Number(this.model.playerRanking);

        await this.rankingService.updateRanking(this.rankingId,this.model).then((resp) => {
          this.operationSuccess();
        });
        this.$router.push(
          `${this.$router.currentRoute.path.split("/editar")[0]}`
        );
        return;
      }
      throw this.$validator.errors.items.map((e) => e.msg);
    } catch (errors) {
      this.operationFailedErrors(errors as Array<string>);
    }
  }

  public clean() {
    this.model = new RankingModel();
  }
}
</script>
